## iscsitarget 1.4.20.3+svn490

=== Makefile ===
#
# Makefile for the Linux kernel device drivers.
#
# Note! Dependencies are done automagically by 'make dep', which also
# removes any old dependencies. DON'T put your own dependencies here
# unless it's something special (not a .c file).
#
# Note 2! The CFLAGS definitions are now in the main makefile.

#export KSRC := /usr/src/linux

DEPMOD = depmod

SUBDIRS := $(shell pwd)

ifeq ($(KSRC),)
	KSRC ?= /lib/modules/$(shell uname -r)/build
endif


ifneq ($(wildcard $(KSRC)/include/generated/utsrelease.h),)
	VERSION_FILE := $(KSRC)/include/generated/utsrelease.h
else
  ifneq ($(wildcard $(KSRC)/include/linux/utsrelease.h),)
	  VERSION_FILE := $(KSRC)/include/linux/utsrelease.h
  else
	  VERSION_FILE := $(KSRC)/include/linux/version.h
  endif
endif

KVER := $(shell $(CC) $(CFLAGS) $(LDFLAGS) -E -dM $(VERSION_FILE) | \
	grep UTS_RELEASE | awk '{ print $$3 }' | sed 's/\"//g')

KMOD := /lib/modules/$(KVER)/extra

KMAJ := $(shell echo $(KVER) | \
	sed -e 's/^\([0-9][0-9]*\)\.[0-9][0-9]*\.[0-9][0-9]*.*/\1/')
KMIN := $(shell echo $(KVER) | \
	sed -e 's/^[0-9][0-9]*\.\([0-9][0-9]*\)\.[0-9][0-9]*.*/\1/')
KREV := $(shell echo $(KVER) | \
	sed -e 's/^[0-9][0-9]*\.[0-9][0-9]*\.\([0-9][0-9]*\).*/\1/')

kver_eq = $(shell [ $(KMAJ) -eq $(1) -a $(KMIN) -eq $(2) -a $(KREV) -eq $(3) ] && \
	echo 1 || echo 0)
kver_lt = $(shell [ $(KMAJ) -lt $(1) -o \
	$(KMAJ) -eq $(1) -a $(KMIN) -lt $(2) -o \
        $(KMAJ) -eq $(1) -a $(KMIN) -eq $(2) -a $(KREV) -lt $(3) ] && \
	echo 1 || echo 0)
kver_le = $(shell [ $(KMAJ) -lt $(1) -o \
        $(KMAJ) -eq $(1) -a $(KMIN) -lt $(2) -o \
        $(KMAJ) -eq $(1) -a $(KMIN) -eq $(2) -a $(KREV) -le $(3) ] && \
	echo 1 || echo 0)
kver_gt = $(shell [ ( $(KMAJ) -gt $(1) ) -o \
        $(KMAJ) -eq $(1) -a $(KMIN) -gt $(2) -o \
        $(KMAJ) -eq $(1) -a $(KMIN) -eq $(2) -a $(KREV) -gt $(3) ] && \
	echo 1 || echo 0)
kver_ge = $(shell [ ( $(KMAJ) -gt $(1) ) -o \
        $(KMAJ) -eq $(1) -a $(KMIN) -gt $(2) -o \
        $(KMAJ) -eq $(1) -a $(KMIN) -eq $(2) -a $(KREV) -ge $(3) ] && \
	echo 1 || echo 0)
kver_lk = $(shell [ `echo $(KVER) | egrep $(1)` ] && echo 1 || echo 0)

#
# Please when adding patch sets start with the latest to the earliest
# the idea behind this is that by properly patching the latest code
# base first the earlier patch sets will not need to be modified.
#

ifeq ($(call kver_le,3,5,0),1)
	PATCHES := $(PATCHES) compat-3.5.patch
endif

ifeq ($(call kver_le,3,4,0),1)
	PATCHES := $(PATCHES) compat-3.2-3.4.patch
endif

ifeq ($(call kver_le,3,2,0),1)
	PATCHES := $(PATCHES) compat-2.6.39-3.2.patch
endif

ifeq ($(call kver_le,2,6,38),1)
	PATCHES := $(PATCHES) compat-2.6.38.patch
endif

ifeq ($(call kver_le,2,6,37),1)
	PATCHES := $(PATCHES) compat-2.6.36-2.6.37.patch
endif

# Compatibility patch for kernels > 2.6.32 <= 2.6.35
ifeq ($(call kver_le,2,6,35),1)
	PATCHES := $(PATCHES) compat-2.6.33-2.6.35.patch
endif

# Compatibility patch for kernels <= 2.6.32
ifeq ($(call kver_le,2,6,32),1)
	PATCHES := $(PATCHES) compat-2.6.32.patch
endif

# Compatibility patch for kernels <= 2.6.31
ifeq ($(call kver_le,2,6,31),1)
	PATCHES := $(PATCHES) compat-2.6.31.patch
endif

# Compatibility patch for kernels <= 2.6.30
ifeq ($(call kver_le,2,6,30),1)
	PATCHES := $(PATCHES) compat-2.6.30.patch
endif

# Compatibility patch for kernels <= 2.6.29
ifeq ($(call kver_le,2,6,29),1)
	PATCHES := $(PATCHES) compat-2.6.29.patch
endif

# Compatibility patch for kernels <= 2.6.28
ifeq ($(call kver_le,2,6,28),1)
	PATCHES := $(PATCHES) compat-2.6.28.patch
endif

# Compatibility patch for kernels >= 2.6.25 and <= 2.6.27
ifeq ($(call kver_le,2,6,27),1)
	PATCHES := $(PATCHES) compat-2.6.25-2.6.27.patch
endif

# Compatibility patch for kernels <= 2.6.24
ifeq ($(call kver_le,2,6,24),1)
	PATCHES := $(PATCHES) compat-2.6.24.patch
endif

# Compatibility patch for kernels <= 2.6.23
ifeq ($(call kver_le,2,6,23),1)
	PATCHES := $(PATCHES) compat-2.6.23.patch
endif

# Compatibility patch for kernels <= 2.6.22
ifeq ($(call kver_le,2,6,22),1)
	PATCHES := $(PATCHES) compat-2.6.22.patch
endif

# Compatibility patch for kernels >= 2.6.19 and <= 2.6.21
ifeq ($(call kver_le,2,6,21),1)
	PATCHES := $(PATCHES) compat-2.6.19-2.6.21.patch
endif

# Compatibility patch for kernels >= 2.6.14 and <= 2.6.18
ifeq ($(call kver_le,2,6,18),1)
	PATCHES := $(PATCHES) compat-2.6.14-2.6.18.patch
endif

# We don't support kernels < 2.6.14 except for explicit distros
ifeq ($(call kver_lt,2,6,14),1)
	UNSUPPORTED := true
endif

# Compatibility patches for SuSE distros
ifneq ($(wildcard /etc/SuSE-release),)
	# Compatibility patch for SLES 10 SP2
	ifeq ($(call kver_lk,"2\.6\.16\.60-.*"),1)
		PATCHES += compat-sles10sp2.patch
		UNSUPPORTED :=
	endif
endif

# Compatibility patches for Redhat distros
ifneq ($(wildcard /etc/redhat-release),)
	# Compatibility patch for RHEL4/CentOS4
	ifeq ($(call kver_lk,"2\.6\.9-.*\.(EL|plus\.c4)"),1)
		PATCHES += compat-rhel4.patch
		UNSUPPORTED :=
	endif
endif

MANPAGES:= ietadm.8 ietd.8 ietd.conf.5

ifeq ($(MANDIR),)
	MANPATH := $(shell (manpath 2>/dev/null || \
		echo $MANPATH) | sed 's/:/ /g')
	ifneq ($(MANPATH),)
		test_dir = $(findstring $(dir), $(MANPATH))
	else
		test_dir = $(shell [ -e $(dir) ] && echo $(dir))
	endif
	MANDIR := /usr/share/man /usr/man
	MANDIR := $(foreach dir, $(MANDIR), $(test_dir))
	MANDIR := $(firstword $(MANDIR))
endif

ifeq ($(MANDIR),)
	MANDIR := /usr/share/man
endif

DOCS:= ChangeLog COPYING RELEASE_NOTES README README.vmware README.initiators

ifeq ($(DOCDIR),)
	DOCDIR := /usr/share/doc/iscsitarget
endif

all: usr kernel

usr: patch
	$(MAKE) -C usr

kernel: patch
	$(MAKE) -C $(KSRC) SUBDIRS=$(shell pwd)/kernel modules

patch: $(UNSUPPORTED) integ_check $(PATCHES)

$(UNSUPPORTED):
	@echo "Sorry, your kernel version and/or distribution is currently"
	@echo "not supported."
	@echo ""
	@echo "Please read the README file for information on how you can"
	@echo "contribute compatibility/bug fixes to the IET project."
	@exit 1

integ_check:
	@if [ -e .patched.* -a ! -e .patched.$(KVER) ]; then \
		$(MAKE) unpatch; \
	fi

$(PATCHES): .patched.$(KVER)

.patched.$(KVER):
	@set -e; \
	if [ ! -e .patched.* ]; then \
		for p in $(PATCHES); do \
			echo "Applying Patch $$p"; \
			patch -p1 < patches/$$p; \
			echo $$p >>.patched.$(KVER); \
		done; \
	fi

unpatch:
	@set -e; \
	if [ -e .patched.* ]; then \
		for p in `cat .patched.*`; do \
			reverse="$$p $$reverse"; \
		done; \
		for r in $$reverse; do \
			echo "Reversing patch $$r"; \
			patch -p1 -R < patches/$$r; \
		done; \
		rm -f .patched.*; \
	fi

depmod:
	@echo "Running depmod"
	@if [ x$(DESTDIR) != x -o x$(INSTALL_MOD_PATH) != x ]; then \
		$(DEPMOD) -aq -b $(DESTDIR)$(INSTALL_MOD_PATH) $(KVER); \
	else \
		$(DEPMOD) -aq $(KVER); \
	fi

install-files: install-usr install-etc install-doc install-kernel

install: install-files depmod

install-kernel: kernel/iscsi_trgt.ko
	@if [ -d $(DESTDIR)$(INSTALL_MOD_PATH)/lib/modules/$(KVER) ]; then \
		if [ -f /etc/debian_version ]; then \
			find $(DESTDIR)$(INSTALL_MOD_PATH)/lib/modules/$(KVER) \
				-name iscsi_trgt.ko -type f \
				-exec /bin/sh -c "dpkg-divert --rename {}" \;; \
		else \
			find $(DESTDIR)$(INSTALL_MOD_PATH)/lib/modules/$(KVER) \
				-name iscsi_trgt.ko -type f \
				-execdir mv \{\} \{\}.orig \;; \
		fi \
	fi
	@install -vD -m 644 kernel/iscsi_trgt.ko \
		$(DESTDIR)$(INSTALL_MOD_PATH)$(KMOD)/iscsi/iscsi_trgt.ko

install-usr: usr/ietd usr/ietadm
	@install -vD usr/ietd $(DESTDIR)/usr/sbin/ietd
	@install -vD usr/ietadm $(DESTDIR)/usr/sbin/ietadm

install-etc: install-initd
	@if [ ! -e $(DESTDIR)/etc/ietd.conf ]; then \
		if [ ! -e $(DESTDIR)/etc/iet/ietd.conf ]; then \
			install -vD -m 640 etc/ietd.conf \
				$(DESTDIR)/etc/iet/ietd.conf; \
		fi \
	fi
	@if [ ! -e $(DESTDIR)/etc/initiators.allow ]; then \
		if [ ! -e $(DESTDIR)/etc/iet/initiators.allow ]; then \
			install -vD -m 644 etc/initiators.allow \
				$(DESTDIR)/etc/iet/initiators.allow; \
		fi \
	fi
	@if [ ! -e $(DESTDIR)/etc/targets.allow ]; then \
		if [ ! -e $(DESTDIR)/etc/iet/targets.allow ]; then \
			install -vD -m 644 etc/targets.allow \
				$(DESTDIR)/etc/iet/targets.allow; \
		fi \
	fi

install-initd:
	@if [ -f /etc/debian_version ]; then \
		install -vD -m 755 etc/initd/initd.debian \
			$(DESTDIR)/etc/init.d/iscsi-target; \
	elif [ -f /etc/redhat-release ]; then \
		install -vD -m 755 etc/initd/initd.redhat \
			$(DESTDIR)/etc/rc.d/init.d/iscsi-target; \
	elif [ -f /etc/gentoo-release ]; then \
		install -vD -m 755 etc/initd/initd.gentoo \
			$(DESTDIR)/etc/init.d/iscsi-target; \
	elif [ -f /etc/slackware-version ]; then \
		install -vD -m 755 etc/initd/initd \
			$(DESTDIR)/etc/rc.d/iscsi-target; \
	else \
		install -vD -m 755 etc/initd/initd \
			$(DESTDIR)/etc/init.d/iscsi-target; \
	fi

install-doc: install-man
	@ok=true; for f in $(DOCS) ; \
		do [ -e $$f ] || \
			{ echo $$f missing ; ok=false; } ; \
	done ; $$ok
	@set -e; for f in $(DOCS) ; do \
		install -v -D -m 644 $$f \
			$(DESTDIR)$(DOCDIR)/$$f ; \
	done

install-man:
	@ok=true; for f in $(MANPAGES) ; \
		do [ -e doc/manpages/$$f ] || \
			{ echo doc/manpages/$$f missing ; ok=false; } ; \
	done ; $$ok
	@set -e; for f in $(MANPAGES) ; do \
		s=$${f##*.}; \
		install -v -D -m 644 doc/manpages/$$f \
			$(DESTDIR)$(MANDIR)/man$$s/$$f ; \
	done

uninstall: uninstall-kernel depmod uninstall-usr uninstall-etc uninstall-doc

uninstall-kernel:
	rm -f $(DESTDIR)$(INSTALL_MOD_PATH)$(KMOD)/iscsi/iscsi_trgt.ko
	@if [ -f /etc/debian_version ]; then \
		find $(DESTDIR)$(INSTALL_MOD_PATH)/lib/modules/$(KVER) \
			-name iscsi_trgt.ko.distrib -type f \
			-exec /bin/sh -c "dpkg-divert --remove --rename \
				\`dirname {}\`/iscsi_trgt.ko" \;; \
	else \
		find $(DESTDIR)$(INSTALL_MOD_PATH)/lib/modules/$(KVER) \
			-name iscsi_trgt.ko.orig -type f \
			-execdir mv \{\} iscsi_trgt.ko \;; \
        fi

uninstall-usr:
	@rm -f $(DESTDIR)/usr/sbin/ietd
	@rm -f $(DESTDIR)/usr/sbin/ietadm

uninstall-etc: uninstall-initd

uninstall-initd:
	if [ -f /etc/debian_version ]; then \
		rm -f $(DESTDIR)/etc/init.d/iscsi-target; \
	elif [ -f /etc/redhat-release ]; then \
		rm -f $(DESTDIR)/etc/rc.d/init.d/iscsi-target; \
	elif [ -f /etc/gentoo-release ]; then \
		rm -f $(DESTDIR)/etc/init.d/iscsi-target; \
	elif [ -f /etc/slackware-version ]; then \
		rm -f $(DESTDIR)/etc/rc.d/iscsi-target; \
	else \
		rm -f $(DESTDIR)/etc/init.d/iscsi-target; \
	fi

uninstall-doc: uninstall-man
	rm -rf $(DESTDIR)$(DOCDIR)

uninstall-man:
	set -e; for f in $(MANPAGES) ; do \
		s=$${f##*.}; \
		rm -f $(DESTDIR)$(MANDIR)/man$$s/$$f ; \
	done

clean:
	$(MAKE) -C usr clean
	$(MAKE) -C $(KSRC) SUBDIRS=$(shell pwd)/kernel clean

distclean: unpatch clean
	find . -name \*.orig -exec rm -f \{\} \;
	find . -name \*.rej -exec rm -f \{\} \;
	find . -name \*~ -exec rm -f \{\} \;
	find . -name Module.symvers -exec rm -f \{\} \;

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# GNU copyright 1997 to 1999 by Joey Hess.
#
# Modified to make a template file for a multi-binary package with separated
# build-arch and build-indep targets  by Bill Allombert 2001

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# This has to be exported to make some magic below work.
export DH_OPTIONS

# get-orig-source target
DEB_UPSTREAM_VERSION=$(shell dpkg-parsechangelog | sed -rne 's,^Version: ([^-]+).*,\1,p')

get-orig-source:
	[ ! -f $(ORIG_FILE).gz ] || rm -f $(ORIG_FILE).gz
	uscan --force-download --rename --repack --download-version=$(DEB_UPSTREAM_VERSION) --destdir=.



non_epoch_version=$(shell echo $(KVERS) | perl -pe 's/^\d+://')

PACKAGE=iscsitarget
pmodules = $(PACKAGE)-module-$(non_epoch_version)

# DKMS package
pdkms=iscsitarget-dkms

CFLAGS = `dpkg-buildflags --get CFLAGS`
CFLAGS += -Wall
CFLAGS += `dpkg-buildflags --get CPPFLAGS`
LDFLAGS = `dpkg-buildflags --get LDFLAGS`
export CFLAGS
export LDFLAGS

ifeq (,$(findstring nostrip,$(DEB_BUILD_OPTIONS)))
	INSTALL_PROGRAM += -s
endif

# module-assistant stuff
MAJOR=$(shell echo $(KVERS) | sed -e 's/\(...\).*/\1/')
ifeq ($(MAJOR),2.6)
KO=k
endif

KERN_VER=$(shell echo $(KVERS) | cut -d "-" -f1)

# Taken from upstream iscsitarget's Makefile
KMAJ := $(shell echo $(KERN_VER) | \
	sed -e 's/^\([0-9][0-9]*\)\.[0-9][0-9]*\.[0-9][0-9]*.*/\1/')
KMIN := $(shell echo $(KERN_VER) | \
	sed -e 's/^[0-9][0-9]*\.\([0-9][0-9]*\)\.[0-9][0-9]*.*/\1/')
KREV := $(shell echo $(KERN_VER) | \
	sed -e 's/^[0-9][0-9]*\.[0-9][0-9]*\.\([0-9][0-9]*\).*/\1/')

kver_eq = $(shell [ $(KMAJ)$(KMIN)$(KREV) -eq $(1)$(2)$(3) ] && \
	echo 1 || echo 0)
kver_lt = $(shell [ $(KMAJ)$(KMIN)$(KREV) -lt $(1)$(2)$(3) ] && \
	echo 1 || echo 0)
kver_le = $(shell [ $(KMAJ)$(KMIN)$(KREV) -le $(1)$(2)$(3) ] && \
	echo 1 || echo 0)
kver_gt = $(shell [ $(KMAJ)$(KMIN)$(KREV) -gt $(1)$(2)$(3) ] && \
	echo 1 || echo 0)
kver_ge = $(shell [ $(KMAJ)$(KMIN)$(KREV) -ge $(1)$(2)$(3) ] && \
	echo 1 || echo 0)
kver_lk = $(shell [ `echo $(KERN_VER) | egrep $(1)` ] && echo 1 || echo 0)

ifeq ($(call kver_lt,3,10,0),1)
    PATCHES := $(PATCHES) compat-3.9.patch
endif

ifeq ($(call kver_lt,3,7,0),1)
    PATCHES := $(PATCHES) compat-3.6.patch
endif

ifeq ($(call kver_le,3,5,0),1)
    PATCHES := $(PATCHES) compat-3.5.patch
endif

ifeq ($(call kver_le,3,4,0),1)
    PATCHES := $(PATCHES) compat-3.2-3.4.patch
endif

ifeq ($(call kver_le,3,2,0),1)
    PATCHES := $(PATCHES) compat-2.6.39-3.2.patch
endif

ifeq ($(call kver_le,2,6,38),1)
    PATCHES := $(PATCHES) compat-2.6.38.patch
endif

ifeq ($(call kver_le,2,6,37),1)
    PATCHES := $(PATCHES) compat-2.6.36-2.6.37.patch
endif

# Compatibility patch for kernels >= 2.6.36  <= 2.6.38
ifeq ($(call kver_le,2,6,38),1)
	PATCHES := $(PATCHES) compat-2.6.36-2.6.37.patch
endif

# Compatibility patch for kernels > 2.6.32 <= 2.6.35
ifeq ($(call kver_le,2,6,35),1)
	PATCHES := $(PATCHES) compat-2.6.33-2.6.35.patch
endif

# Compatibility patch for kernels <= 2.6.32
ifeq ($(call kver_le,2,6,32),1)
	PATCHES := $(PATCHES) compat-2.6.32.patch
endif

# Compatibility patch for kernels <= 2.6.31
ifeq ($(call kver_le,2,6,31),1)
	PATCHES := $(PATCHES) compat-2.6.31.patch
endif

# Compatibility patch for kernels <= 2.6.30
ifeq ($(call kver_le,2,6,30),1)
	PATCHES := $(PATCHES) compat-2.6.30.patch
endif

# Compatibility patch for kernels <= 2.6.29
ifeq ($(call kver_le,2,6,29),1)
	PATCHES := $(PATCHES) compat-2.6.29.patch
endif

# Compatibility patch for kernels <= 2.6.28
ifeq ($(call kver_le,2,6,28),1)
	PATCHES := $(PATCHES) compat-2.6.28.patch
endif

# Compatibility patch for kernels >= 2.6.25 and <= 2.6.27
ifeq ($(call kver_le,2,6,27),1)
	PATCHES := $(PATCHES) compat-2.6.25-2.6.27.patch
endif

# Compatibility patch for kernels <= 2.6.24
ifeq ($(call kver_le,2,6,24),1)
	PATCHES := $(PATCHES) compat-2.6.24.patch
endif

# Compatibility patch for kernels <= 2.6.23
ifeq ($(call kver_le,2,6,23),1)
	PATCHES := $(PATCHES) compat-2.6.23.patch
endif

# Compatibility patch for kernels <= 2.6.22
ifeq ($(call kver_le,2,6,22),1)
	PATCHES := $(PATCHES) compat-2.6.22.patch
endif

# Compatibility patch for kernels >= 2.6.19 and <= 2.6.21
ifeq ($(call kver_le,2,6,21),1)
	PATCHES := $(PATCHES) compat-2.6.19-2.6.21.patch
endif

# Compatibility patch for kernels >= 2.6.14 and <= 2.6.18
ifeq ($(call kver_le,2,6,18),1)
	PATCHES := $(PATCHES) compat-2.6.14-2.6.18.patch
endif

# We don't support kernels < 2.6.14 except for explicit distros
ifeq ($(call kver_lt,2,6,14),1)
	echo "unsupported kernel"
	exit 1
endif


kdist_clean:
	dh_clean
	$(MAKE) -C $(KSRC) SUBDIRS=$(shell pwd)/kernel clean

# prep-deb-files rewrites the debian/ files as needed. See RATIONALE for
# details
kdist_config: prep-deb-files
	for p in $(PATCHES); do \
		echo "Applying patch $$p"; \
		test -f patches/$$p && patch -p1 < patches/$$p \
		#test -f patches/compat-$(KERN_VER).patch && patch -p1 < patches/compat-$(KERN_VER).patch \
	done

kdist_configure: kdist_config

binary-modules: prep-deb-files
	dh_testdir
	dh_testroot
	dh_clean -k
	#$(MAKE) -C $(KSRC) KERNEL_SOURCES=$(KSRC) MODVERSIONS=detect KERNEL=linux-$(KVERS) KDIR=$(KSRC) SUBDIRS=$(shell pwd)/kernel modules
	$(MAKE) -C $(KSRC) SUBDIRS=$(shell pwd)/kernel modules
	
	#$(MAKE) -C $(KSRC) SUBDIRS=$(shell pwd)/kernel modules_install DESTDIR=$(CURDIR)/debian/$(pmodules)
	install -m644 -b -D $(shell pwd)/kernel/iscsi_trgt.$(KO)o $(CURDIR)/debian/${pmodules}/lib/modules/$(KVERS)/kernel/drivers/iscsi/iscsi_trgt.$(KO)o

	dh_installdocs
	dh_installchangelogs
	dh_compress
	dh_fixperms
	dh_installdeb
	dh_gencontrol -- -v$(VERSION)
	dh_md5sums
	dh_builddeb --destdir=$(DEB_DESTDIR)

#Architecture 
build: build-arch build-indep

build-arch: build-arch-stamp
build-arch-stamp: 
	dh_testdir
	$(MAKE) -C usr
	touch build-arch-stamp

build-indep: build-indep-stamp
build-indep-stamp: 
	touch build-indep-stamp

clean:
	dh_testdir
	dh_testroot
	rm -f build-arch-stamp build-indep-stamp #CONFIGURE-STAMP#
	$(MAKE) -C usr clean
	dh_clean 

install: install-arch install-indep
install-indep:
	dh_testdir
	dh_testroot
	dh_clean -k -i 
	dh_installdirs -i
	
	# For DKMS
	# Create the directories to install the source into
	dh_installdirs -p$(pdkms)  usr/src/$(PACKAGE)-$(DEB_UPSTREAM_VERSION)
	dh_installdirs -p$(pdkms)  usr/src/$(PACKAGE)-$(DEB_UPSTREAM_VERSION)/debian
	dh_installdirs -p$(pdkms)  usr/src/$(PACKAGE)-$(DEB_UPSTREAM_VERSION)/include
	dh_installdirs -p$(pdkms)  usr/src/$(PACKAGE)-$(DEB_UPSTREAM_VERSION)/kernel
	dh_installdirs -p$(pdkms)  usr/src/$(PACKAGE)-$(DEB_UPSTREAM_VERSION)/patches
	
	# Copy only the driver source to the proper location
	cp kernel/*  debian/$(pdkms)/usr/src/$(PACKAGE)-$(DEB_UPSTREAM_VERSION)/kernel/
	cp include/* debian/$(pdkms)/usr/src/$(PACKAGE)-$(DEB_UPSTREAM_VERSION)/include/
	cp patches/* debian/$(pdkms)/usr/src/$(PACKAGE)-$(DEB_UPSTREAM_VERSION)/patches/
	
	# Copy the needed debian/ pieces to the proper location
	cp debian/*-module-* \
		debian/$(pdkms)/usr/src/$(PACKAGE)-$(DEB_UPSTREAM_VERSION)/debian
	chmod 755 debian/$(pdkms)/usr/src/$(PACKAGE)-$(DEB_UPSTREAM_VERSION)/debian/*-module-*
	cp debian/control.modules.in \
		debian/$(pdkms)/usr/src/$(PACKAGE)-$(DEB_UPSTREAM_VERSION)/debian/control.in
	cp debian/rules \
		debian/$(pdkms)/usr/src/$(PACKAGE)-$(DEB_UPSTREAM_VERSION)/debian
	cp debian/changelog \
		debian/$(pdkms)/usr/src/$(PACKAGE)-$(DEB_UPSTREAM_VERSION)/debian
	cp debian/copyright \
		debian/$(pdkms)/usr/src/$(PACKAGE)-$(DEB_UPSTREAM_VERSION)/debian
	
	# install debian/ files
	cd debian ; cp changelog control compat *.modules.in rules copyright $(pdkms)/usr/src/$(PACKAGE)-$(DEB_UPSTREAM_VERSION)/debian
	
	# create toplevel module Makefile
	echo "obj-m = kernel/" > debian/$(pdkms)/usr/src/$(PACKAGE)-$(DEB_UPSTREAM_VERSION)/Makefile
	
	# Prepare dkms.conf from the dkms.conf.in template

## iscsitarget 1.4.20.3+svn499

=== Makefile ===
--- 
+++ 
@@ -66,15 +66,27 @@
 # base first the earlier patch sets will not need to be modified.
 #
 
-ifeq ($(call kver_le,3,5,0),1)
+ifeq ($(call kver_lt,3,13,0),1)
+	PATCHES := $(PATCHES) compat-3.12.patch
+endif
+
+ifeq ($(call kver_lt,3,10,0),1)
+	PATCHES := $(PATCHES) compat-3.9.patch
+endif
+
+ifeq ($(call kver_lt,3,7,0),1)
+	PATCHES := $(PATCHES) compat-3.6.patch
+endif
+
+ifeq ($(call kver_lt,3,6,0),1)
 	PATCHES := $(PATCHES) compat-3.5.patch
 endif
 
-ifeq ($(call kver_le,3,4,0),1)
+ifeq ($(call kver_lt,3,5,0),1)
 	PATCHES := $(PATCHES) compat-3.2-3.4.patch
 endif
 
-ifeq ($(call kver_le,3,2,0),1)
+ifeq ($(call kver_lt,3,3,0),1)
 	PATCHES := $(PATCHES) compat-2.6.39-3.2.patch
 endif

=== debian/changelog ===
iscsitarget (1.4.20.3+svn499-0ubuntu2.6) trusty; urgency=medium

  * Fix ADT requirements to run daemon test only when isolation
    level machine is available.

 -- Stefan Bader <stefan.bader@canonical.com>  Mon, 28 Jan 2019 11:16:06 +0100

iscsitarget (1.4.20.3+svn499-0ubuntu2.5) trusty; urgency=medium

  * Fix daemon dep8 test so it really tests for the running
    daemon (LP: #1734855).

 -- Stefan Bader <stefan.bader@canonical.com>  Thu, 01 Feb 2018 16:48:03 +0100

iscsitarget (1.4.20.3+svn499-0ubuntu2.4) trusty; urgency=medium

  * Remove compat code for 4.4.0-84 and detect sock_recvmsg signature
    during build. (LP: #1732746)

 -- Thadeu Lima de Souza Cascardo <cascardo@canonical.com>  Fri, 17 Nov 2017 17:47:16 +0000

iscsitarget (1.4.20.3+svn499-0ubuntu2.3) trusty; urgency=medium

  * d/p/(porting|compat|enable)-4.4.0-84.patch:
    Add compat code to build with Ubuntu 4.4.0-84 (LP: #1701697)
  
 -- Thadeu Lima de Souza Cascardo <cascardo@canonical.com>  Wed, 12 Jul 2017 20:13:41 +0000

iscsitarget (1.4.20.3+svn499-0ubuntu2.2) trusty; urgency=medium

  * Backport compat changes to allow DKMS compiles for kernels up to 4.4
    (LP: #1612627).
    - d/p/fix-build-4.3.patch: Fix source to compile with 4.3+
      kernels.  Thanks to Stefan Bader <stefan.bader@canonical.com>.
    - d/p/add-4.3-compat.patch: Add compat-4.3.patch to DKMS patches.
      Thanks to Stefan Bader <stefan.bader@canonical.com>.
    - d/p/enable-4.3-compat.patch: Enable compat-4.3 patch for DKMS
      builds.  Thanks to Stefan Bader <stefan.bader@canonical.com>.

 -- Nishanth Aravamudan <nish.aravamudan@canonical.com>  Mon, 20 Mar 2017 17:07:43 -0700

=== debian/control ===
Source: iscsitarget
Section: net
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian iSCSI Maintainers <pkg-iscsi-maintainers@lists.alioth.debian.org>
Uploaders: Philipp Hug <debian@hug.cx>, Guido Guenther <agx@sigxcpu.org>, Frederik Schüler <fs@debian.org>, Ritesh Raj Sarraf <rrs@debian.org>
Build-Depends: debhelper (>= 5.0.0), libssl-dev, bzip2
Standards-Version: 3.9.2
Homepage: http://iscsitarget.sourceforge.net/
Vcs-Git: git://git.debian.org/git/pkg-iscsi/iscsitarget.git
Vcs-Browser: http://git.debian.org/?p=pkg-iscsi/iscsitarget.git
XS-Testsuite: autopkgtest

Package: iscsitarget
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, procps, lsb-base (>= 3.2-14)
Recommends: iscsitarget-dkms
Conflicts: iscsitarget-source
Description: iSCSI Enterprise Target userland tools
 iSCSI Enterprise Target is for building an iSCSI storage system on
 Linux. It is aimed at developing an iSCSI target satisfying enterprise
 requirements.
 .
 This package contains the userland part; you require the kernel module 
 for proper operation.

Package: iscsitarget-dkms
Architecture: all
Depends: dkms (>= 1.95), make, ${misc:Depends}
Recommends: linux-headers
Suggests: iscsitarget
Conflicts: iscsitarget-source
Description: iSCSI Enterprise Target kernel module source - dkms version
 iSCSI Enterprise Target is for building an iSCSI storage system on
 Linux. It is aimed at developing an iSCSI target satisfying enterprise
 requirements.
 .
 This package provides the source code for the iscsitarget kernel module.
 The iscsitarget package is also required in order to make use of this
 module. Kernel source or headers are required to compile this module.
 .
 This package contains the source to be built with dkms.

=== debian/rules ===
--- 
+++ 
@@ -67,6 +67,10 @@
 kver_ge = $(shell [ $(KMAJ)$(KMIN)$(KREV) -ge $(1)$(2)$(3) ] && \
 	echo 1 || echo 0)
 kver_lk = $(shell [ `echo $(KERN_VER) | egrep $(1)` ] && echo 1 || echo 0)
+
+ifeq ($(call kver_lt,3,13,0),1)
+    PATCHES := $(PATCHES) compat-3.12.patch
+endif
 
 ifeq ($(call kver_lt,3,10,0),1)
     PATCHES := $(PATCHES) compat-3.9.patch
@@ -241,6 +245,10 @@
 	cp kernel/*  debian/$(pdkms)/usr/src/$(PACKAGE)-$(DEB_UPSTREAM_VERSION)/kernel/
 	cp include/* debian/$(pdkms)/usr/src/$(PACKAGE)-$(DEB_UPSTREAM_VERSION)/include/
 	cp patches/* debian/$(pdkms)/usr/src/$(PACKAGE)-$(DEB_UPSTREAM_VERSION)/patches/
+
+	# Copy prebuild script
+	install -m 755 debian/configure_features.sh \
+		debian/$(pdkms)/usr/src/$(PACKAGE)-$(DEB_UPSTREAM_VERSION)/
 	
 	# Copy the needed debian/ pieces to the proper location
 	cp debian/*-module-* \
@@ -259,6 +267,3 @@
 	cd debian ; cp changelog control compat *.modules.in rules copyright $(pdkms)/usr/src/$(PACKAGE)-$(DEB_UPSTREAM_VERSION)/debian
 	
 	# create toplevel module Makefile
-	echo "obj-m = kernel/" > debian/$(pdkms)/usr/src/$(PACKAGE)-$(DEB_UPSTREAM_VERSION)/Makefile
-	
-	# Prepare dkms.conf from the dkms.conf.in template

=== debian/tests/control ===
Test-Command: modprobe iscsi_trgt
Depends: iscsitarget, iscsitarget-dkms
Restrictions: needs-root, isolation-machine

Tests: daemon
Depends: iscsitarget, iscsitarget-dkms
Restrictions: needs-root, isolation-machine

=== debian/watch ===
version=3
http://sf.net/iscsitarget/iscsitarget-(.+)\.tar\.gz

## iscsitarget 1.4.20.3+svn502

=== Makefile ===
--- 
+++ 
@@ -66,6 +66,10 @@
 # base first the earlier patch sets will not need to be modified.
 #
 
+ifeq ($(call kver_lt,3,14,0),1)
+	PATCHES := $(PATCHES) compat-3.13.patch
+endif
+
 ifeq ($(call kver_lt,3,13,0),1)
 	PATCHES := $(PATCHES) compat-3.12.patch
 endif

=== kernel/Makefile ===
#
# Makefile for the Linux kernel device drivers.
#
# Note! Dependencies are done automagically by 'make dep', which also
# removes any old dependencies. DON'T put your own dependencies here
# unless it's something special (not a .c file).
#
# Note 2! The CFLAGS definitions are now in the main makefile.

EXTRA_CFLAGS += -I$(src)/../include 

obj-m		+= iscsi_trgt.o
iscsi_trgt-objs	:= tio.o iscsi.o nthread.o wthread.o config.o digest.o \
			conn.o session.o target.o volume.o iotype.o \
			file-io.o null-io.o target_disk.o event.o param.o \
			block-io.o ua.o persist.o

=== usr/Makefile ===
CFLAGS += -O2 -fno-inline -Wall -Wstrict-prototypes -I../include
CFLAGS += -D_GNU_SOURCE # required for glibc >= 2.8
PROGRAMS = ietd ietadm
LIBS =

all: $(PROGRAMS)

ietd: ietd.o iscsid.o conn.o session.o target.o message.o ctldev.o log.o chap.o event.o param.o plain.o isns.o md5.o sha1.o

	$(CC) $(LDFLAGS) $^ -o $@ $(LIBS)

ietadm: ietadm.o param.o
	$(CC) $(LDFLAGS) $^ -o $@

clean:
	rm -f *.o $(PROGRAMS)

=== debian/changelog ===
iscsitarget (1.4.20.3+svn502-2) unstable; urgency=medium

  * [b17e4aa] Add patch to extend dkms buils in chroot environments.
    Thanks to Philipp Hahn (Closes: #766989)

 -- Ritesh Raj Sarraf <rrs@debian.org>  Tue, 28 Oct 2014 15:44:22 +0530

iscsitarget (1.4.20.3+svn502-1) unstable; urgency=medium

  * [f81dcec] Imported Upstream version 1.4.20.3+svn502
    Closes: #746821
  * [cdf7cbd] Fix Vcs links

 -- Ritesh Raj Sarraf <rrs@debian.org>  Thu, 08 May 2014 18:38:46 +0530

=== debian/control ===
--- 
+++ 
@@ -1,15 +1,13 @@
 Source: iscsitarget
 Section: net
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian iSCSI Maintainers <pkg-iscsi-maintainers@lists.alioth.debian.org>
+Maintainer: Debian iSCSI Maintainers <pkg-iscsi-maintainers@lists.alioth.debian.org>
 Uploaders: Philipp Hug <debian@hug.cx>, Guido Guenther <agx@sigxcpu.org>, Frederik Schüler <fs@debian.org>, Ritesh Raj Sarraf <rrs@debian.org>
-Build-Depends: debhelper (>= 5.0.0), libssl-dev, bzip2
+Build-Depends: debhelper (>= 5.0.0), libssl-dev, bzip2, dkms
 Standards-Version: 3.9.2
 Homepage: http://iscsitarget.sourceforge.net/
-Vcs-Git: git://git.debian.org/git/pkg-iscsi/iscsitarget.git
-Vcs-Browser: http://git.debian.org/?p=pkg-iscsi/iscsitarget.git
-XS-Testsuite: autopkgtest
+Vcs-Git: git://anonscm.debian.org/pkg-iscsi/iscsitarget.git
+Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-iscsi/iscsitarget.git
 
 Package: iscsitarget
 Architecture: any

=== debian/rules ===
--- 
+++ 
@@ -67,38 +67,6 @@
 kver_ge = $(shell [ $(KMAJ)$(KMIN)$(KREV) -ge $(1)$(2)$(3) ] && \
 	echo 1 || echo 0)
 kver_lk = $(shell [ `echo $(KERN_VER) | egrep $(1)` ] && echo 1 || echo 0)
-
-ifeq ($(call kver_lt,3,13,0),1)
-    PATCHES := $(PATCHES) compat-3.12.patch
-endif
-
-ifeq ($(call kver_lt,3,10,0),1)
-    PATCHES := $(PATCHES) compat-3.9.patch
-endif
-
-ifeq ($(call kver_lt,3,7,0),1)
-    PATCHES := $(PATCHES) compat-3.6.patch
-endif
-
-ifeq ($(call kver_le,3,5,0),1)
-    PATCHES := $(PATCHES) compat-3.5.patch
-endif
-
-ifeq ($(call kver_le,3,4,0),1)
-    PATCHES := $(PATCHES) compat-3.2-3.4.patch
-endif
-
-ifeq ($(call kver_le,3,2,0),1)
-    PATCHES := $(PATCHES) compat-2.6.39-3.2.patch
-endif
-
-ifeq ($(call kver_le,2,6,38),1)
-    PATCHES := $(PATCHES) compat-2.6.38.patch
-endif
-
-ifeq ($(call kver_le,2,6,37),1)
-    PATCHES := $(PATCHES) compat-2.6.36-2.6.37.patch
-endif
 
 # Compatibility patch for kernels >= 2.6.36  <= 2.6.38
 ifeq ($(call kver_le,2,6,38),1)
@@ -245,10 +213,6 @@
 	cp kernel/*  debian/$(pdkms)/usr/src/$(PACKAGE)-$(DEB_UPSTREAM_VERSION)/kernel/
 	cp include/* debian/$(pdkms)/usr/src/$(PACKAGE)-$(DEB_UPSTREAM_VERSION)/include/
 	cp patches/* debian/$(pdkms)/usr/src/$(PACKAGE)-$(DEB_UPSTREAM_VERSION)/patches/
-
-	# Copy prebuild script
-	install -m 755 debian/configure_features.sh \
-		debian/$(pdkms)/usr/src/$(PACKAGE)-$(DEB_UPSTREAM_VERSION)/
 	
 	# Copy the needed debian/ pieces to the proper location
 	cp debian/*-module-* \
@@ -267,3 +231,37 @@
 	cd debian ; cp changelog control compat *.modules.in rules copyright $(pdkms)/usr/src/$(PACKAGE)-$(DEB_UPSTREAM_VERSION)/debian
 	
 	# create toplevel module Makefile
+	echo "obj-m = kernel/" > debian/$(pdkms)/usr/src/$(PACKAGE)-$(DEB_UPSTREAM_VERSION)/Makefile
+	
+	# Prepare dkms.conf from the dkms.conf.in template
+	sed "s/__VERSION__/$(DEB_UPSTREAM_VERSION)/g" debian/dkms.conf.in > debian/dkms.conf
+	grep ^PATCH dkms.conf >> debian/dkms.conf
+	dh_dkms -p$(pdkms) -- debian/dkms.conf
+
+	dh_install -i
+
+install-arch:
+	dh_testdir
+	dh_testroot
+	dh_clean -k -s 
+	dh_installdirs -s
+	dh_install -s
+	
+	# install override
+	mkdir -p debian/iscsitarget/usr/share/lintian/overrides
+	cp debian/iscsitarget.overrides \
+		debian/iscsitarget/usr/share/lintian/overrides/iscsitarget
+
+# Must not depend on anything. This is to be called by
+# binary-arch/binary-indep
+# in another 'make' thread.
+binary-common:
+	dh_testdir
+	dh_testroot
+	dh_installchangelogs ChangeLog
+	dh_installdocs
+	dh_installinit
+	dh_installman
+	dh_link
+	dh_strip
+	dh_compress
